diff --git a/editversions.cgi b/editversions.cgi
index 23de88071..707e998d6 100755
--- a/editversions.cgi
+++ b/editversions.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/editwhines.cgi b/editwhines.cgi
index c677273bd..4b8da9b6e 100755
--- a/editwhines.cgi
+++ b/editwhines.cgi
@@ -10,7 +10,7 @@
 # Script Initialization
 ################################################################################
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/editworkflow.cgi b/editworkflow.cgi
index 81b665e42..019dfb74f 100755
--- a/editworkflow.cgi
+++ b/editworkflow.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/email_in.pl b/email_in.pl
index a03935830..eecda81bf 100755
--- a/email_in.pl
+++ b/email_in.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
@@ -24,7 +24,7 @@ BEGIN {
 use lib qw(. lib);
 
 use Data::Dumper;
-use Email::Address;
+use Email::Address::XS;
 use Email::Reply qw(reply);
 use Email::MIME;
 use Getopt::Long qw(:config bundling);
@@ -129,7 +129,7 @@ sub parse_mail {
 
   %fields = %{Bugzilla::Bug::map_fields(\%fields)};
 
-  my ($reporter) = Email::Address->parse($input_email->header('From'));
+  my ($reporter) = Email::Address::XS->parse($input_email->header('From'));
   $fields{'reporter'} = $reporter->address;
 
   # The summary line only affects us if we're doing a post_bug.
diff --git a/enter_bug.cgi b/enter_bug.cgi
index b4f609500..1ec06d02b 100755
--- a/enter_bug.cgi
+++ b/enter_bug.cgi
@@ -16,7 +16,7 @@
 #
 ##############################################################################
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/extensions/BmpConvert/Config.pm b/extensions/BmpConvert/Config.pm
index ed2df6197..aabb8142e 100644
--- a/extensions/BmpConvert/Config.pm
+++ b/extensions/BmpConvert/Config.pm
@@ -7,7 +7,7 @@
 
 package Bugzilla::Extension::BmpConvert;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/extensions/BmpConvert/Extension.pm b/extensions/BmpConvert/Extension.pm
index 84a2c81dc..64d011fee 100644
--- a/extensions/BmpConvert/Extension.pm
+++ b/extensions/BmpConvert/Extension.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::BmpConvert;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::Extension);
+use base qw(Bugzilla::Extension);
 
 use Image::Magick;
 
diff --git a/extensions/Example/Config.pm b/extensions/Example/Config.pm
index 696da2de9..34d6659db 100644
--- a/extensions/Example/Config.pm
+++ b/extensions/Example/Config.pm
@@ -7,7 +7,7 @@
 
 package Bugzilla::Extension::Example;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/extensions/Example/Extension.pm b/extensions/Example/Extension.pm
index 1ecb3e692..8201781f7 100644
--- a/extensions/Example/Extension.pm
+++ b/extensions/Example/Extension.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::Example;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::Extension);
+use base qw(Bugzilla::Extension);
 
 use Bugzilla::Constants;
 use Bugzilla::Error;
diff --git a/extensions/Example/lib/Auth/Login.pm b/extensions/Example/lib/Auth/Login.pm
index 49af42c22..71a0b7371 100644
--- a/extensions/Example/lib/Auth/Login.pm
+++ b/extensions/Example/lib/Auth/Login.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::Example::Auth::Login;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::Auth::Login);
+use base qw(Bugzilla::Auth::Login);
 use constant user_can_create_account => 0;
 use Bugzilla::Constants;
 
diff --git a/extensions/Example/lib/Auth/Verify.pm b/extensions/Example/lib/Auth/Verify.pm
index 591c1d4f8..401a00315 100644
--- a/extensions/Example/lib/Auth/Verify.pm
+++ b/extensions/Example/lib/Auth/Verify.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::Example::Auth::Verify;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::Auth::Verify);
+use base qw(Bugzilla::Auth::Verify);
 use Bugzilla::Constants;
 
 # A verifier that always fails.
diff --git a/extensions/Example/lib/Config.pm b/extensions/Example/lib/Config.pm
index 360a57510..d7d7ace72 100644
--- a/extensions/Example/lib/Config.pm
+++ b/extensions/Example/lib/Config.pm
@@ -7,7 +7,7 @@
 
 package Bugzilla::Extension::Example::Config;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/extensions/Example/lib/Util.pm b/extensions/Example/lib/Util.pm
index ccc349c9c..88a9a5a84 100644
--- a/extensions/Example/lib/Util.pm
+++ b/extensions/Example/lib/Util.pm
@@ -7,7 +7,7 @@
 
 package Bugzilla::Extension::Example::Util;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/extensions/Example/lib/WebService.pm b/extensions/Example/lib/WebService.pm
index f461fee6f..b11edc578 100644
--- a/extensions/Example/lib/WebService.pm
+++ b/extensions/Example/lib/WebService.pm
@@ -7,10 +7,10 @@
 
 package Bugzilla::Extension::Example::WebService;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
-use parent qw(Bugzilla::WebService);
+use base qw(Bugzilla::WebService);
 use Bugzilla::Error;
 
 use constant PUBLIC_METHODS => qw(
diff --git a/extensions/MoreBugUrl/Config.pm b/extensions/MoreBugUrl/Config.pm
index f8175bb4c..0fea92c0f 100644
--- a/extensions/MoreBugUrl/Config.pm
+++ b/extensions/MoreBugUrl/Config.pm
@@ -7,7 +7,7 @@
 
 package Bugzilla::Extension::MoreBugUrl;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/extensions/MoreBugUrl/Extension.pm b/extensions/MoreBugUrl/Extension.pm
index a6eae1be5..42244d0d9 100644
--- a/extensions/MoreBugUrl/Extension.pm
+++ b/extensions/MoreBugUrl/Extension.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::MoreBugUrl;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::Extension);
+use base qw(Bugzilla::Extension);
 
 use constant MORE_SUB_CLASSES => qw(
   Bugzilla::Extension::MoreBugUrl::BitBucket
@@ -22,6 +22,7 @@ use constant MORE_SUB_CLASSES => qw(
   Bugzilla::Extension::MoreBugUrl::PHP
   Bugzilla::Extension::MoreBugUrl::Redmine
   Bugzilla::Extension::MoreBugUrl::Savane
+  Bugzilla::Extension::MoreBugUrl::WineHQForums
 );
 
 # We need to update bug_see_also table because both
diff --git a/extensions/MoreBugUrl/lib/BitBucket.pm b/extensions/MoreBugUrl/lib/BitBucket.pm
index 683f9aeb3..6a3809298 100644
--- a/extensions/MoreBugUrl/lib/BitBucket.pm
+++ b/extensions/MoreBugUrl/lib/BitBucket.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::MoreBugUrl::BitBucket;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::BugUrl);
+use base qw(Bugzilla::BugUrl);
 
 ###############################
 ####        Methods        ####
diff --git a/extensions/MoreBugUrl/lib/GetSatisfaction.pm b/extensions/MoreBugUrl/lib/GetSatisfaction.pm
index 34c86b65f..6d62b9b6a 100644
--- a/extensions/MoreBugUrl/lib/GetSatisfaction.pm
+++ b/extensions/MoreBugUrl/lib/GetSatisfaction.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::MoreBugUrl::GetSatisfaction;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::BugUrl);
+use base qw(Bugzilla::BugUrl);
 
 ###############################
 ####        Methods        ####
diff --git a/extensions/MoreBugUrl/lib/PHP.pm b/extensions/MoreBugUrl/lib/PHP.pm
index 9419bcd14..e326d8222 100644
--- a/extensions/MoreBugUrl/lib/PHP.pm
+++ b/extensions/MoreBugUrl/lib/PHP.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::MoreBugUrl::PHP;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::BugUrl);
+use base qw(Bugzilla::BugUrl);
 
 ###############################
 ####        Methods        ####
diff --git a/extensions/MoreBugUrl/lib/RT.pm b/extensions/MoreBugUrl/lib/RT.pm
index 54dc2dd4c..d23675d6e 100644
--- a/extensions/MoreBugUrl/lib/RT.pm
+++ b/extensions/MoreBugUrl/lib/RT.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::MoreBugUrl::RT;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::BugUrl);
+use base qw(Bugzilla::BugUrl);
 
 ###############################
 ####        Methods        ####
diff --git a/extensions/MoreBugUrl/lib/Redmine.pm b/extensions/MoreBugUrl/lib/Redmine.pm
index 712dab197..e21ba2e56 100644
--- a/extensions/MoreBugUrl/lib/Redmine.pm
+++ b/extensions/MoreBugUrl/lib/Redmine.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::MoreBugUrl::Redmine;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::BugUrl);
+use base qw(Bugzilla::BugUrl);
 
 ###############################
 ####        Methods        ####
diff --git a/extensions/MoreBugUrl/lib/ReviewBoard.pm b/extensions/MoreBugUrl/lib/ReviewBoard.pm
index 48cbecf11..1da4c4c9e 100644
--- a/extensions/MoreBugUrl/lib/ReviewBoard.pm
+++ b/extensions/MoreBugUrl/lib/ReviewBoard.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::MoreBugUrl::ReviewBoard;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::BugUrl);
+use base qw(Bugzilla::BugUrl);
 
 ###############################
 ####        Methods        ####
diff --git a/extensions/MoreBugUrl/lib/Rietveld.pm b/extensions/MoreBugUrl/lib/Rietveld.pm
index 55a18b0b2..7febde237 100644
--- a/extensions/MoreBugUrl/lib/Rietveld.pm
+++ b/extensions/MoreBugUrl/lib/Rietveld.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::MoreBugUrl::Rietveld;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::BugUrl);
+use base qw(Bugzilla::BugUrl);
 
 ###############################
 ####        Methods        ####
diff --git a/extensions/MoreBugUrl/lib/Savane.pm b/extensions/MoreBugUrl/lib/Savane.pm
index ff0cd657f..69fa10a9d 100644
--- a/extensions/MoreBugUrl/lib/Savane.pm
+++ b/extensions/MoreBugUrl/lib/Savane.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::MoreBugUrl::Savane;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::BugUrl);
+use base qw(Bugzilla::BugUrl);
 
 ###############################
 ####        Methods        ####
diff --git a/extensions/OldBugMove/Config.pm b/extensions/OldBugMove/Config.pm
index 681cbae2d..851e4ea0b 100644
--- a/extensions/OldBugMove/Config.pm
+++ b/extensions/OldBugMove/Config.pm
@@ -7,7 +7,7 @@
 
 package Bugzilla::Extension::OldBugMove;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/extensions/OldBugMove/Extension.pm b/extensions/OldBugMove/Extension.pm
index 70dc5ad30..05f77f2fd 100644
--- a/extensions/OldBugMove/Extension.pm
+++ b/extensions/OldBugMove/Extension.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::OldBugMove;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::Extension);
+use base qw(Bugzilla::Extension);
 use Bugzilla::Constants;
 use Bugzilla::Error;
 use Bugzilla::Field::Choice;
@@ -183,7 +183,7 @@ sub _move_bug {
   my @fieldlist = (Bugzilla::Bug->fields, 'group', 'long_desc', 'attachment',
     'attachmentdata');
   my %displayfields = map { $_ => 1 } @fieldlist;
-  my $vars = {bugs => [$export_me], displayfields => \%displayfields};
+  my $vars          = {bugs => [$export_me], displayfields => \%displayfields};
   $template->process("bug/show.xml.tmpl", $vars, \$msg)
     || ThrowTemplateError($template->error());
   $msg .= "\n";
diff --git a/extensions/OldBugMove/lib/Params.pm b/extensions/OldBugMove/lib/Params.pm
index e1bab048b..f6a61c0eb 100644
--- a/extensions/OldBugMove/lib/Params.pm
+++ b/extensions/OldBugMove/lib/Params.pm
@@ -7,7 +7,7 @@
 
 package Bugzilla::Extension::OldBugMove::Params;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/extensions/Voting/Config.pm b/extensions/Voting/Config.pm
index d72caa3cc..81625f85c 100644
--- a/extensions/Voting/Config.pm
+++ b/extensions/Voting/Config.pm
@@ -7,7 +7,7 @@
 
 package Bugzilla::Extension::Voting;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/extensions/Voting/Extension.pm b/extensions/Voting/Extension.pm
index a46162ed2..f8674837a 100644
--- a/extensions/Voting/Extension.pm
+++ b/extensions/Voting/Extension.pm
@@ -7,11 +7,11 @@
 
 package Bugzilla::Extension::Voting;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use parent qw(Bugzilla::Extension);
+use base qw(Bugzilla::Extension);
 
 use Bugzilla::Bug;
 use Bugzilla::BugMail;
diff --git a/extensions/create.pl b/extensions/create.pl
index f2aa3f933..60667b47c 100755
--- a/extensions/create.pl
+++ b/extensions/create.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/importxml.pl b/importxml.pl
index 96264cb0a..3be5bd2b7 100755
--- a/importxml.pl
+++ b/importxml.pl
@@ -10,7 +10,7 @@
 # a new bug into bugzilla. Everything before the beginning <?xml line
 # is removed so you can pipe in email messages.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
@@ -595,10 +595,10 @@ sub process_bug {
     format_time($bug_fields{'delta_ts'}, "%Y-%m-%d %T") || $timestamp);
 
   # Bug Access
-  push(@query, "cclist_accessible");
+  push(@query,  "cclist_accessible");
   push(@values, $bug_fields{'cclist_accessible'} ? 1 : 0);
 
-  push(@query, "reporter_accessible");
+  push(@query,  "reporter_accessible");
   push(@values, $bug_fields{'reporter_accessible'} ? 1 : 0);
 
   my $product = new Bugzilla::Product({name => $bug_fields{'product'} || ''});
diff --git a/index.cgi b/index.cgi
index 474c5c7ce..9985a94c5 100755
--- a/index.cgi
+++ b/index.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/install-module.pl b/install-module.pl
index 972b4baca..40ec32dca 100755
--- a/install-module.pl
+++ b/install-module.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/jobqueue.pl b/jobqueue.pl
index 310cf4d26..913a0e0af 100755
--- a/jobqueue.pl
+++ b/jobqueue.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/jsonrpc.cgi b/jsonrpc.cgi
index 6933e26cb..bbb058f4c 100755
--- a/jsonrpc.cgi
+++ b/jsonrpc.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/migrate.pl b/migrate.pl
index 061509027..aa46b1b02 100755
--- a/migrate.pl
+++ b/migrate.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/mod_perl.pl b/mod_perl.pl
index 98f3365ca..8bd89e9f3 100644
--- a/mod_perl.pl
+++ b/mod_perl.pl
@@ -8,7 +8,7 @@
 
 package Bugzilla::ModPerl;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
@@ -113,7 +113,7 @@ foreach my $file (glob "$cgi_path/*.cgi") {
 
 package Bugzilla::ModPerl::ResponseHandler;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
@@ -149,7 +149,7 @@ sub handler : method {
 
 package Bugzilla::ModPerl::CleanupHandler;
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/page.cgi b/page.cgi
index 930eb58df..eefffb9ac 100755
--- a/page.cgi
+++ b/page.cgi
@@ -13,7 +13,7 @@
 # a content-type, e.g. html.
 ###############################################################################
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/post_bug.cgi b/post_bug.cgi
index 757db7fdf..aa639a1e4 100755
--- a/post_bug.cgi
+++ b/post_bug.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/process_bug.cgi b/process_bug.cgi
index 3adce62c1..17ed5a1ee 100755
--- a/process_bug.cgi
+++ b/process_bug.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/query.cgi b/query.cgi
index 0c176f987..d7c217788 100755
--- a/query.cgi
+++ b/query.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/quips.cgi b/quips.cgi
index 671ec1f09..98d05d945 100755
--- a/quips.cgi
+++ b/quips.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/relogin.cgi b/relogin.cgi
index 2cd9bb25c..bc9eb1c87 100755
--- a/relogin.cgi
+++ b/relogin.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/report.cgi b/report.cgi
index 7895115b3..6aebe20dc 100755
--- a/report.cgi
+++ b/report.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
@@ -312,13 +312,6 @@ $vars->{'height'}          = $height;
 $vars->{'queries'}         = $extra_data;
 $vars->{'saved_report_id'} = $cgi->param('saved_report_id');
 
-if ( $cgi->param('debug')
-  && Bugzilla->params->{debug_group}
-  && Bugzilla->user->in_group(Bugzilla->params->{debug_group}))
-{
-  $vars->{'debug'} = 1;
-}
-
 if ($action eq "wrap") {
 
   # So which template are we using? If action is "wrap", we will be using
@@ -367,24 +360,9 @@ else {
 my $format = $template->get_format("reports/report", $formatparam,
   scalar($cgi->param('ctype')));
 
-# If we get a template or CGI error, it comes out as HTML, which isn't valid
-# PNG data, and the browser just displays a "corrupt PNG" message. So, you can
-# set debug=1 to always get an HTML content-type, and view the error.
-$format->{'ctype'} = "text/html" if $cgi->param('debug');
-
 $cgi->set_dated_content_disp("inline", "report", $format->{extension});
 print $cgi->header($format->{'ctype'});
 
-# Problems with this CGI are often due to malformed data. Setting debug=1
-# prints out both data structures.
-if ($cgi->param('debug')) {
-  require Data::Dumper;
-  say "<pre>data hash:";
-  say html_quote(Data::Dumper::Dumper(%data));
-  say "\ndata array:";
-  say html_quote(Data::Dumper::Dumper(@image_data)) . "\n\n</pre>";
-}
-
 # All formats point to the same section of the documentation.
 $vars->{'doc_section'} = 'using/reports-and-charts.html#reports';
 
diff --git a/reports.cgi b/reports.cgi
index 860a537d8..66873e40b 100755
--- a/reports.cgi
+++ b/reports.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/request.cgi b/request.cgi
index 97978ccad..a95ac5399 100755
--- a/request.cgi
+++ b/request.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/rest.cgi b/rest.cgi
index 892cb62dd..d07957d7f 100755
--- a/rest.cgi
+++ b/rest.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/runtests.pl b/runtests.pl
index 92e9df806..89a05b46e 100755
--- a/runtests.pl
+++ b/runtests.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use diagnostics;
 use strict;
 use warnings;
diff --git a/sanitycheck.cgi b/sanitycheck.cgi
index 3d4334e93..a04fd9be2 100755
--- a/sanitycheck.cgi
+++ b/sanitycheck.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
@@ -119,7 +119,7 @@ if ($cgi->param('createmissinggroupcontrolmapentries')) {
   # Find all group/product combinations used for bugs but not set up
   # correctly in group_control_map
   my $invalid_combinations = $dbh->selectall_arrayref(
-    qq{    SELECT bugs.product_id,
+    "SELECT bugs.product_id,
                       bgm.group_id,
                       gcm.membercontrol,
                       groups.name,
@@ -127,15 +127,14 @@ if ($cgi->param('createmissinggroupcontrolmapentries')) {
                  FROM bugs
            INNER JOIN bug_group_map AS bgm
                    ON bugs.bug_id = bgm.bug_id
-           INNER JOIN groups
+           INNER JOIN " . $dbh->quote_identifier('groups') . "
                    ON bgm.group_id = groups.id
            INNER JOIN products
                    ON bugs.product_id = products.id
             LEFT JOIN group_control_map AS gcm
                    ON bugs.product_id = gcm.product_id
                   AND    bgm.group_id = gcm.group_id
-                WHERE COALESCE(gcm.membercontrol, $na) = $na
-          }
+                WHERE COALESCE(gcm.membercontrol, $na) = $na "
       . $dbh->sql_group_by(
       'bugs.product_id, bgm.group_id',
       'gcm.membercontrol, groups.name, products.name'
@@ -366,7 +365,7 @@ if ($cgi->param('remove_old_whine_targets')) {
     my $old_ids = $dbh->selectcol_arrayref(
       "SELECT DISTINCT mailto
                                       FROM whine_schedules
-                                 LEFT JOIN $table
+                                 LEFT JOIN " . $dbh->quote_identifier($table) . "
                                         ON $table.$col = whine_schedules.mailto
                                      WHERE mailto_type = $type AND $table.$col IS NULL"
     );
@@ -438,13 +437,14 @@ sub CrossCheck {
     Status('cross_check_from', {table => $refertable, field => $referfield});
 
     my $query
-      = qq{SELECT DISTINCT $refertable.$referfield}
-      . ($keyname ? qq{, $refertable.$keyname } : q{})
-      . qq{ FROM $refertable
-                    LEFT JOIN $table
+      = "SELECT DISTINCT $refertable.$referfield"
+      . ($keyname ? ", $refertable.$keyname " : "")
+      . " FROM "
+      . $dbh->quote_identifier($refertable) . "
+                    LEFT JOIN " . $dbh->quote_identifier($table) . "
                            ON $refertable.$referfield = $table.$field
                         WHERE $table.$field IS NULL
-                          AND $refertable.$referfield IS NOT NULL};
+                          AND $refertable.$referfield IS NOT NULL";
 
     my $sth = $dbh->prepare($query);
     $sth->execute;
@@ -661,14 +661,14 @@ sub DoubleCrossCheck {
       qq{
                         SELECT DISTINCT $refertable.$referfield1, 
                                         $refertable.$referfield2 }
-        . ($keyname ? qq{, $refertable.$keyname } : q{}) . qq{ FROM $refertable
-                     LEFT JOIN $table
+        . ($keyname ? qq{, $refertable.$keyname } : q{}) . " FROM $refertable
+                     LEFT JOIN " . $dbh->quote_identifier($table) . "
                             ON $refertable.$referfield1 = $table.$field1
                            AND $refertable.$referfield2 = $table.$field2 
                          WHERE $table.$field1 IS NULL 
                            AND $table.$field2 IS NULL 
                            AND $refertable.$referfield1 IS NOT NULL 
-                           AND $refertable.$referfield2 IS NOT NULL}
+                           AND $refertable.$referfield2 IS NOT NULL"
     );
 
     foreach my $check (@$d_cross_check) {
@@ -973,7 +973,7 @@ BugCheck(
   "bugs
          INNER JOIN group_control_map
             ON bugs.product_id = group_control_map.product_id
-         INNER JOIN groups
+         INNER JOIN " . $dbh->quote_identifier('groups') . "
             ON group_control_map.group_id = groups.id
           LEFT JOIN bug_group_map
             ON bugs.bug_id = bug_group_map.bug_id
@@ -1018,7 +1018,7 @@ foreach my $target (['groups', 'id', MAILTO_GROUP],
   my $old = $dbh->selectall_arrayref(
     "SELECT whine_schedules.id, mailto
                                           FROM whine_schedules
-                                     LEFT JOIN $table
+                                     LEFT JOIN " . $dbh->quote_identifier($table) . "
                                             ON $table.$col = whine_schedules.mailto
                                          WHERE mailto_type = $type AND $table.$col IS NULL"
   );
diff --git a/sanitycheck.pl b/sanitycheck.pl
index bd1bec8d3..3fcf450ec 100755
--- a/sanitycheck.pl
+++ b/sanitycheck.pl
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/search_plugin.cgi b/search_plugin.cgi
index 46dce5ee2..85e7c76a6 100755
--- a/search_plugin.cgi
+++ b/search_plugin.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/show_activity.cgi b/show_activity.cgi
index fefd68b8a..e604be3cb 100755
--- a/show_activity.cgi
+++ b/show_activity.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/show_bug.cgi b/show_bug.cgi
index 64a99d11b..2839abbc0 100755
--- a/show_bug.cgi
+++ b/show_bug.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/showdependencygraph.cgi b/showdependencygraph.cgi
index 666a6626e..bf9d560e8 100755
--- a/showdependencygraph.cgi
+++ b/showdependencygraph.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/showdependencytree.cgi b/showdependencytree.cgi
index 94ac15107..c4542b42e 100755
--- a/showdependencytree.cgi
+++ b/showdependencytree.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/summarize_time.cgi b/summarize_time.cgi
index 9f4e658f3..293a15332 100755
--- a/summarize_time.cgi
+++ b/summarize_time.cgi
@@ -6,7 +6,7 @@
 # This Source Code Form is "Incompatible With Secondary Licenses", as
 # defined by the Mozilla Public License, v. 2.0.
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
diff --git a/t/001compile.t b/t/001compile.t
index ad29975af..e9ee6deb7 100644
--- a/t/001compile.t
+++ b/t/001compile.t
@@ -10,7 +10,7 @@
 #Bugzilla Test 1#
 ###Compilation###
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
@@ -84,7 +84,9 @@ SKIP: {
 
     # Check that we have a DBI module to support the DB, if this
     # is a database module (but not Schema)
-    if ($file =~ m{Bugzilla/DB/([^/]+)\.pm$} and $file ne "Bugzilla/DB/Schema.pm") {
+    if ($file =~ m{Bugzilla/DB/([^/]+)\.pm$}
+      and $file ne "Bugzilla/DB/Schema.pm"
+      and $file ne "Bugzilla/DB/QuoteIdentifier.pm") {
       my $module = lc($1);
       my $dbd    = DB_MODULE->{$module}->{dbd}->{module};
       eval("use $dbd; 1") or skip "$file: $dbd not installed", 1;
diff --git a/t/002goodperl.t b/t/002goodperl.t
index 837849282..a20a58b90 100644
--- a/t/002goodperl.t
+++ b/t/002goodperl.t
@@ -10,11 +10,11 @@
 #Bugzilla Test 2#
 ####GoodPerl#####
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use lib 't';
+use lib qw(. lib t);
 
 use Support::Files;
 
@@ -86,6 +86,8 @@ foreach my $file (@testitems) {
 }
 
 foreach my $file (@testitems) {
+  my $enables_strict_re = qr/^\s*use\s+(?:strict|Moo)\s*;/;
+  my $enables_warnings_re = qr/^\s*use\s+(?:warnings|Moo)\s*;/;
   my $found_use_perl     = 0;
   my $found_use_strict   = 0;
   my $found_use_warnings = 0;
@@ -97,17 +99,17 @@ foreach my $file (@testitems) {
     next;
   }
   while (my $file_line = <FILE>) {
-    $found_use_perl     = 1 if $file_line =~ m/^\s*use 5.10.1/;
-    $found_use_strict   = 1 if $file_line =~ m/^\s*use strict/;
-    $found_use_warnings = 1 if $file_line =~ m/^\s*use warnings/;
+    $found_use_perl     = 1 if $file_line =~ m/^\s*use 5.14.0/;
+    $found_use_strict   = 1 if $file_line =~ $enables_strict_re;
+    $found_use_warnings = 1 if $file_line =~ $enables_warnings_re;
     last if ($found_use_perl && $found_use_strict && $found_use_warnings);
   }
   close(FILE);
   if ($found_use_perl) {
-    ok(1, "$file requires Perl 5.10.1");
+    ok(1, "$file requires Perl 5.14.0");
   }
   else {
-    ok(0, "$file DOES NOT require Perl 5.10.1 --WARNING");
+    ok(0, "$file DOES NOT require Perl 5.14.0 --WARNING");
   }
 
   if ($found_use_strict) {
diff --git a/t/003safesys.t b/t/003safesys.t
index 3cc55f835..759c7231c 100644
--- a/t/003safesys.t
+++ b/t/003safesys.t
@@ -10,11 +10,11 @@
 #Bugzilla Test 3#
 ###Safesystem####
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use lib 't';
+use lib qw(. lib t);
 
 use Support::Files;
 
diff --git a/t/004template.t b/t/004template.t
index 938ee8b18..515aad6c8 100644
--- a/t/004template.t
+++ b/t/004template.t
@@ -9,11 +9,11 @@
 #Bugzilla Test 4#
 ####Templates####
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use lib 't';
+use lib qw(. lib t);
 
 use Support::Templates;
 
@@ -140,10 +140,10 @@ foreach my $include_path (@include_paths) {
 
     # Forbid single quotes to delimit URLs, see bug 926085.
     if ($data =~ /href=\\?'/) {
-      ok(0, "$path contains blacklisted constructs: href='...'");
+      ok(0, "$path contains blocklisted constructs: href='...'");
     }
     else {
-      ok(1, "$path contains no blacklisted constructs");
+      ok(1, "$path contains no blocklisted constructs");
     }
   }
 }
diff --git a/t/005whitespace.t b/t/005whitespace.t
index ef589e693..fffb4361c 100644
--- a/t/005whitespace.t
+++ b/t/005whitespace.t
@@ -9,11 +9,11 @@
 #Bugzilla Test 5#
 #####no_tabs#####
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use lib 't';
+use lib qw(. lib t);
 
 use Support::Files;
 use Support::Templates;
diff --git a/t/006spellcheck.t b/t/006spellcheck.t
index ccbd69932..587b5a1b7 100644
--- a/t/006spellcheck.t
+++ b/t/006spellcheck.t
@@ -10,11 +10,11 @@
 #Bugzilla Test 6#
 ####Spelling#####
 
-use 5.10.1;
+use 5.14.0;
 use strict;
 use warnings;
 
-use lib 't';
+use lib qw(. lib t);
 use Support::Files;
 
 # -1 because 006spellcheck.t must not be checked.
